package com.adlerneves.git.teste_admissional_2020_12_14.adapters

import android.view.View
import androidx.recyclerview.widget.RecyclerView

abstract class AbstractRecyclerViewAdapterWithData<T>(dataListParam: List<T>) :
    RecyclerView.Adapter<AbstractRecyclerViewAdapterWithData<T>.DataAndViewHolder<T>>() {
    inner class DataAndViewHolder<T>(itemView: View, var data: T? = null) :
        RecyclerView.ViewHolder(itemView)

    var dataList = dataListParam
        private set

    override fun onBindViewHolder(holder: DataAndViewHolder<T>, position: Int) {
        val data = dataList[position]
        holder.data = data
        onBindViewHolder(holder, position, data)
    }

    abstract fun onBindViewHolder(holder: DataAndViewHolder<T>, position: Int, data: T)
    override fun getItemCount(): Int = dataList.size
}