package com.adlerneves.git.teste_admissional_2020_12_14.endpoints

import com.adlerneves.git.teste_admissional_2020_12_14.helper_extensions.toList
import com.adlerneves.git.teste_admissional_2020_12_14.models.RedditPost
import org.json.JSONObject

class SubredditEndpoint(subreddit: String) :
    AbstractHttpEndpoint<List<RedditPost>>("https://www.reddit.com/r/$subreddit.json?raw_json=1") {
    override fun processGetResponse(dataBytes: ByteArray): List<RedditPost> {
        val response = JSONObject(String(dataBytes, Charsets.UTF_8))
        assert(response.getString("kind") == "Listing")
        return response
            .getJSONObject("data")
            .getJSONArray("children")
            .toList<JSONObject>()
            .filterNotNull()
            .filter { it.getString("kind") == "t3" }
            .map { it.getJSONObject("data") }
            .map { RedditPost.fromJSONObject(it) }
            .toList()
    }
}