package com.adlerneves.git.teste_admissional_2020_12_14.helper_extensions

import org.json.JSONArray
import org.json.JSONObject

fun JSONObject.optNullableBoolean(name: String, fallback: Boolean? = null): Boolean? {
    return if (this.has(name) && !this.isNull(name)) {
        this.getBoolean(name)
    } else {
        fallback
    }
}

fun JSONObject.optNullableString(name: String, fallback: String? = null): String? {
    return if (this.has(name) && !this.isNull(name)) {
        this.getString(name)
    } else {
        fallback
    }
}

fun JSONObject.optNullableDouble(name: String, fallback: Double? = null): Double? {
    return if (this.has(name) && !this.isNull(name)) {
        this.getDouble(name)
    } else {
        fallback
    }
}

fun JSONObject.optNullableInt(name: String, fallback: Int? = null): Int? {
    return if (this.has(name) && !this.isNull(name)) {
        this.getInt(name)
    } else {
        fallback
    }
}

fun JSONObject.optNullableJSONArray(name: String, fallback: JSONArray? = null): JSONArray? {
    return if (this.has(name) && !this.isNull(name)) {
        this.getJSONArray(name)
    } else {
        fallback
    }
}

fun JSONObject.optNullableJSONObject(name: String, fallback: JSONObject? = null): JSONObject? {
    return if (this.has(name) && !this.isNull(name)) {
        this.getJSONObject(name)
    } else {
        fallback
    }
}

fun JSONObject.optNullableLong(name: String, fallback: Long? = null): Long? {
    return if (this.has(name) && !this.isNull(name)) {
        this.getLong(name)
    } else {
        fallback
    }
}